
package de.ivu.elect.business.gruppe.boundary;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.gruppe.entity.Gruppe;

@RequestScoped
@Named(GruppeConversationSelect.COMPONENT_NAME)
public class GruppeConversationSelect implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "gruppeConversationSelect";

  @Inject
  protected transient GruppeExtendedDAO entityDAO;

  @Inject
  @ConversationGroup(GruppeConversationStore.class)
  protected transient GruppeConversationStore conversationStore;

  public GruppeConversationSelect() {
    super();
  }

  public boolean isSelected() {
    return getEntityPK() != null;
  }

  public Gruppe getEntity() {
    return getEntityInternal();
  }

  private Gruppe getEntityInternal() {
    if (getEntityPK() == null) {
      return null;
    }

    return attach(getEntityPK());
  }

  public void setEntity(Gruppe entity) {
    setEntityAttached(attach(entity));
  }

  public void setEntity( de.ivu.elect.business.gruppe.entity.GruppePK  pk) {
    setEntityAttached(attach(pk));
  }

  protected void setEntityAttached(Gruppe entity) {
    if(entity == null) {
      setEntityPK(null);
    } else {
      setEntityPK(entity.getPk());
    }
  }

  public
    de.ivu.elect.business.gruppe.entity.GruppePK
   getEntityPK() {
    return conversationStore.getEntityPK();
  }

  public void setEntityPK(
    de.ivu.elect.business.gruppe.entity.GruppePK
   entityPK) {
    conversationStore.setEntityPK(entityPK);
  }

  protected Gruppe attach(Gruppe entity) {
    if (entity == null){
      return null;
    }

    return attach(entity.getPk());
  }

  protected Gruppe attach( de.ivu.elect.business.gruppe.entity.GruppePK  pk) {
    if (pk == null) {
      return null;
    }

    return entityDAO.findByPrimaryKey(pk);
  }

  public void clearEntity() {
    setEntityPK(null);

    conversationStore.close();
  }
}
